package commons.pfc;

import java.io.File;
import java.io.IOException;
import javax.security.auth.login.LoginException;
import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class subir_imagen extends AndromediacommonsActivity
{
	private Button bt_subirImagen;
	private ProgressDialog progressBar;
	private int progressBarStatus = 0;
 
	 @Override
	    public void onCreate(Bundle savedInstanceState)
	 {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.subir_imagen);
	        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
	        inicializar();// se queda esperando a la escucha de que se pulse el boton de subir imagen
	 }
	 
	 public void inicializar() 
	 {
		 bt_subirImagen = (Button) findViewById(R.id.btsubir);
		 bt_subirImagen.setOnClickListener(
	                 new OnClickListener() 
	                 {
						   @Override
						   public void onClick(View v) 
						   {
								// preparando el cuadro de dialogo
								progressBar = new ProgressDialog(v.getContext());
								progressBar.setCancelable(true);
								progressBar.setMessage("Subiendo imagen a wikimidia commons ...");
								progressBar.setProgressStyle(ProgressDialog.STYLE_SPINNER);
								progressBar.setProgress(0);
								progressBar.setMax(100);
								progressBar.show();
								progressBarStatus = 0;//cuadro de dialogo a 0
								
								new Thread(new Runnable() 
								{
								  public void run() 
								  {
									while (progressBarStatus < 100) 
									{			 
										// Empieza la tarea en segundo plano.
										try { progressBarStatus = subida_imagen(); }
										catch (LoginException e1) {// TODO Auto-generated catch block
											e1.printStackTrace(); }
										catch (IOException e1) {// TODO Auto-generated catch block
										e1.printStackTrace(); }
									}
									// Imagen subida
									if (progressBarStatus >= 100)
										progressBar.dismiss();
								  }
								}).start();

						  }
	 
	                 });
		 
	 }
	 
	// Subida de la imagen, devuelve 100 que es el status del cuadro de dialogo
	public int subida_imagen() throws LoginException, IOException 
	{
		File imgFile = new File(datos.path);
	    String contenido = Datos_Imagen();										
	    usuario.upload(imgFile, datos.nom_imagen, contenido ,datos.descripcion_corta);
	    Siguiente_Layout();
		return 100;
	}
	 
	 private String Datos_Imagen()
	    {
		    StringBuilder contenido = new StringBuilder();
		    
		    contenido.append("=={{int:filedesc}}==" +'\n');//Descripcin del archivo
		    if((datos.latitud != "" && datos.latitud != "No disponible"))// && (datos.longitud != "" || datos.longitud != "No disponible") && datos.altitud != "")
		    	contenido.append("{{Location dec|" + datos.latitud + "|" + datos.longitud + "|" + datos.altitud + "}}" + '\n');//Localizacin del archivo(latitud-longitud-altitud)
		    contenido.append("{{Information" + '\n');
		    contenido.append("|description={{es|1=" + datos.descripcion + "}}" + '\n'); //Descripcion espaol| 1-> numero de intervenciones = lo que se quiera poner.
		    contenido.append("|date=" + datos.fecha + '\n');//Fecha
		    contenido.append("|source={{own}}" + '\n');
		    contenido.append("|author=[[User:"+ usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
		    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) +
		    		"|" + usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
		    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) 
		    		+ "]]" + '\n');//Autro de la subida
		    contenido.append("|permission=" + '\n');
		    contenido.append("|other_versions=" + '\n');
		    contenido.append("|other_fields=" + '\n');
		    contenido.append("}}" + '\n');
		    contenido.append("=={{int:license-header}}==" + '\n');//Licencia del archivo
		    contenido.append("{{" + datos.licencia + "}}" + '\n');//Tipo de licencia
		    contenido.append("[[Category:Uploaded with AndromediaCommons]]" + '\n');//Software desde el que se sube el archvo
		    if(datos.categoria.length() != 0)
		    	contenido.append("[[Category:" + datos.categoria + "]]");//Categoria
	    	
	    	return contenido.toString();
	    }

	 private void Siguiente_Layout()
	 {
		    Intent intent = new Intent();
			intent.setComponent(new ComponentName(this, info_salir.class));
			progressBar.dismiss();
			startActivity(intent);
	 }
	 
}
